﻿#target photoshop
/*

// BEGIN__HARVEST_EXCEPTION_ZSTRING

<javascriptresource>
<name>$$$/JavaScripts/DotA_Gallery_Save_All/Menu=DotA HUD Export...</name>
<about>$$$/JavaScripts/DotA_Gallery_Save_All/About=DotA HUD Export^rSave all HUD elements as PNGs in the correct directory structure^rby Bronwen Grimes^r04/16/2013</about>
<category>_PlaceAtTopCuzISaidSo_DotA</category>
<enableinfo>true</enableinfo>
</javascriptresource>

// END__HARVEST_EXCEPTION_ZSTRING

*/

if(layerExist("preview_one")){
    if(activeDocument.activeLayer.visible == false){activeDocument.activeLayer.visible =true;}
    executeAction(sTID('newPlacedLayer'), undefined, DialogModes.NO);  
   }

function layerExist(lyrName){       
    var desc = new ActionDescriptor(); 
    var ref = new ActionReference(); 
    ref.putName( cTID( "Lyr " ), lyrName); 
    desc.putReference( cTID( "null" ), ref ); 
    desc.putBoolean( cTID( "MkVs" ), false ); 
    try{ executeAction( cTID( "slct" ), desc, DialogModes.NO ); }catch(e){return false;}
    return true;
};
 
function cTID(s) { return app.charIDToTypeID(s); };           
function sTID(s) { return app.stringIDToTypeID(s); };

if(layerExist("preview_two")){
    if(activeDocument.activeLayer.visible == false){activeDocument.activeLayer.visible =true;}
    executeAction(sTID('newPlacedLayer'), undefined, DialogModes.NO);  
   }


 
function cTID(s) { return app.charIDToTypeID(s); };           
function sTID(s) { return app.stringIDToTypeID(s); };

if(layerExist("preview_three")){
    if(activeDocument.activeLayer.visible == false){activeDocument.activeLayer.visible =true;}
    executeAction(sTID('newPlacedLayer'), undefined, DialogModes.NO);  
   }


 
function cTID(s) { return app.charIDToTypeID(s); };           
function sTID(s) { return app.stringIDToTypeID(s); };
var iconElements = [ "icon", "preview_one", "preview_two", "preview_three", "loadingscreen" ];
var actionpanelElements = [ "center_left",  "center_left_wide", "center_right", "minimapborder", "portrait", "portrait_wide", "spacer_16_9", "spacer_16_10", "light_4_3", "light_16_9", "light_16_10" ];
var inventoryElements = [ "background_4_3", "background_wide", "rocks_4_3", "rocks_16_9", "rocks_16_10", "spacer", "stash_upper", "stash_active_lower", "stash_lower", "light_right_4_3", "light_right_16_9", "light_right_16_10" ];
var scoreboardElements = [ "dayNight", "topbar" ];

function element( name, layer )
{
    this.name = name;
    this.layer = layer;
}

function elementGroup( name, elements )
{
    this.name = name;
    this.elements = new Array();
    for ( i = 0; i < elements.length; i++ )
    {
        this.elements.push( new element( elements[ i ] ) );
    }
}

function editSmartObject( doc, layer )
{
    doc.activeLayer = layer;
    var idAction = stringIDToTypeID( "placedLayerEditContents" );	
    var idDesc = new ActionDescriptor();
    executeAction(idAction, idDesc, DialogModes.NO);
}

function collectSmartObjects( currentSet, collection )
{
    for ( var i = 0; i < currentSet.artLayers.length; i++ )
    {
        if ( currentSet.artLayers[ i ].kind == LayerKind.SMARTOBJECT )
        {
            collection.push( currentSet.artLayers[ i ] );
        }
    }
    for ( var i = 0; i < currentSet.layerSets.length; i++ )
    {
        collectSmartObjects( currentSet.layerSets[ i ], collection );
    }
}

function validateFile( doc, eg )
{
    var candidateSmartObjects = new Array();
    collectSmartObjects( doc, candidateSmartObjects );
    for ( i = 0; i < eg.length; i++ )
    {
        for ( j = 0; j < eg[ i ].elements.length; j++ )
        {
            e = eg[ i ].elements[ j ];
            for ( k = 0; k < candidateSmartObjects.length; k++ )
            {
                c = candidateSmartObjects[ k ];
                if ( e.name == c.name )
                {
                    e.layer = c;
                }
            }
            if ( e.layer == null )
            {
                alert( "Malformed HUD file: missing element " + e.name + ".");
                return false;
            }
        }
    }
    return true;
}

function HUD_export()
{
   try
    {
        var doc = app.activeDocument;
    }
    catch( e )
    {
        return;
    }

    var elementGroups = [ new elementGroup( "", iconElements ), new elementGroup( "actionpanel", actionpanelElements ), new elementGroup( "inventory", inventoryElements ), new elementGroup( "scoreboard", scoreboardElements ) ];
         
    if ( validateFile( doc, elementGroups ) )
    {

        parentFolder = Folder( doc.path + "/" + ( doc.name.substr( 0, doc.name.lastIndexOf('.') ) ) );
        if ( !parentFolder.exists )
        {
            parentFolder.create();
        }
        for( i = 0; i < elementGroups.length; i++ )
        {
            newPath = Folder( parentFolder + "/" + elementGroups[ i ].name );
            if ( !newPath.exists )
            {
                newPath.create();
            }
            for ( j = 0; j < elementGroups[ i ].elements.length; j++ )
            {
                e = elementGroups[ i ].elements[ j ];
                editSmartObject( doc, e.layer );
                eDoc = app.activeDocument;
                saveOptions = new PNGSaveOptions( false );
                targetFile = File( newPath + "/" + e.name + ".png" );
                eDoc.saveAs( targetFile, saveOptions, true, Extension.LOWERCASE );
                eDoc.close( SaveOptions.DONOTSAVECHANGES );
            }
        }
    }
}

HUD_export()